#ifndef DEF_HEADER_AVL
#define DEF_HEADER_AVL

#define ERREUR_MEMOIRE -1
#define ERREUR_UTILISATION -2
#define ERREUR_DEJA_FAIT -3

#define SPLIT_VALUE (~((int)0))

typedef int (*Comparaison)(const void *, const void *);

typedef struct _NoeudAVL NoeudAVL, *AVL;
struct _NoeudAVL
{
	void * valeur;
	int bal;
	AVL gauche;
	AVL droite;
};

/* Gestion mémoire */

AVL AVL_creer_noeud(const void * valeur);

void AVL_free(AVL * a, void (*free_element)(void *));

/* Fonctions utilisateur */

int AVL_ajouter(AVL * a, const void * valeur, Comparaison cmp);

AVL AVL_extraire(AVL * a, const void * valeur, Comparaison cmp);

AVL AVL_trouver(const AVL a, const void * valeur, Comparaison cmp);

AVL AVL_trouver_split(const AVL a, const void * valeur, Comparaison cmp);

#endif
