#include <stdio.h>
#include <stdlib.h>

#include "automate_base.h"

Automate Automate_creer()
{
	Automate automate = NULL;
	if((automate = (Automate)malloc(sizeof(Automate_aux))) == NULL)
		return NULL;
		
	automate->alphabet = NULL;
	automate->etats = NULL;
	automate->etats_init = NULL;
	automate->etats_finaux = NULL;
	automate->transitions = NULL;
	
	if((automate->alphabet = Ensemble_creer(TYPE_MOT, 0)) == NULL
	|| (automate->etats = Ensemble_creer(TYPE_ETAT, 0)) == NULL
	|| (automate->etats_init = Ensemble_creer(TYPE_ETAT, 1)) == NULL
	|| (automate->etats_finaux = Ensemble_creer(TYPE_ETAT, 1)) == NULL
	|| (automate->transitions = Ensemble_creer(TYPE_TRANSITION, 0)) == NULL)
	{
		Automate_free(&automate);
		return NULL;
	}
	
	return automate;
}

void Automate_free(Automate * automate)
{
	if(automate == NULL || *automate == NULL)
		return;
		
	Ensemble_free(&((*automate)->alphabet));
	Ensemble_free(&((*automate)->etats));
	Ensemble_free(&((*automate)->etats_init));
	Ensemble_free(&((*automate)->etats_finaux));
	Ensemble_free(&((*automate)->transitions));
	
	free(*automate);
	*automate = NULL;
}
