#ifndef DEF_HEADER_AUTOMATE_EDIT
#define DEF_HEADER_AUTOMATE_EDIT

#include "automate_base.h"
#include "elements.h"

/* Ajouts */

Mot premiere_lettre(Mot mot);

int Automate_ajouter_lettre(Automate automate, Mot lettre);

int Automate_ajouter_etat(Automate automate, Mot etat_nom);

int Automate_ajouter_transition(Automate automate, Mot etat_depart, Mot lettre, Mot etat_arrivee);

int Automate_ajouter_etat_initial(Automate automate, Mot etat_nom);

int Automate_ajouter_etat_final(Automate automate, Mot etat_nom);

int Automate_copier(Automate * dest, Automate source);

int Automate_ajouter_automate(Automate automate, Automate autre, Mot prefixe1, Mot prefixe2);

/* Existence */

int Automate_existe_lettre(Automate automate, Mot lettre);

int Automate_existe_etat(Automate automate, Mot etat_nom);

int Automate_existe_transition(Automate automate, Mot etat_depart, Mot lettre, Mot etat_arrivee);

/* Suppressions */

int Automate_supprimer_lettre(Automate automate, Mot lettre);

int Automate_supprimer_etat(Automate automate, Mot etat_nom);

int Automate_supprimer_transition(Automate automate, Mot etat_depart, Mot lettre, Mot etat_arrivee);

int Automate_supprimer_lettres_sans_transitions(Automate automate);

int Automate_supprimer_transitions_etat(Automate automate, Mot etat_nom);

int Automate_supprimer_etats_ensemble(Automate automate, Ensemble etats);

int Automate_supprimer_transitions_etats_ensemble(Automate automate, Ensemble etats);

int Automate_supprimer_etats_non_accessibles(Automate automate);

int Automate_supprimer_etats_non_coaccessibles(Automate automate);

/* Propriétés pour suppressions */

int Automate_lettre_sans_transition(Automate automate, Mot lettre);

int Automate_etat_isole(Automate automate, Mot etat_nom);

/* Modifications */

int Automate_renommer_etats_par_prefixe(Automate automate, Mot prefixe);

int Automate_renommer_etats_par_nombre(Automate automate);

#endif
