#include <stdio.h>
#include <stdlib.h>

#include "automate_save.h"

int Automate_sauv_aux_trans(Automate automate, const AVL cur, FILE * sortie)
{
	if(cur == NULL)
		return 1;
	if(cur->valeur == NULL)
		return 0;
	fprintf(sortie, " %s %s", (char *)(((Transition)(cur->valeur))->lettre), (char *)(((Transition)(cur->valeur))->arrivee->nom));
	if(! Automate_sauv_aux_trans(automate, cur->gauche, sortie))
		return 0;
	if(! Automate_sauv_aux_trans(automate, cur->droite, sortie))
		return 0;
	return 1;
}

int Automate_sauv_aux(Automate automate, const AVL cur, FILE * sortie)
{
	int nb_tr = 0;
	Etat etat = NULL;
	if(cur == NULL)
		return 1;
	if(! Automate_sauv_aux(automate, cur->gauche, sortie))
		return 0;
	if((etat = (Etat)(cur->valeur)) == NULL)
		return 0;
	fprintf(sortie, "%s %d %d", (char *)(etat->nom), Ensemble_trouver(automate->etats_init, etat) + (2 * Ensemble_trouver(automate->etats_finaux, etat)), Ensemble_nombre_elements(etat->suivants));
	if(! Automate_sauv_aux_trans(automate, etat->suivants->elements, sortie))
		return 0;
	fprintf(sortie, "\n");
	if(! Automate_sauv_aux(automate, cur->droite, sortie))
		return 0;
	return 1;
}

int Automate_sauvegarder(Automate automate, FILE * sortie)
{
	if(automate == NULL || sortie == NULL)
		return 0;
	if(! Automate_sauv_aux(automate, automate->etats->elements, sortie))
		return 0;
	return 1;
}

int Automate_charger_etat(Automate automate, FILE * entree)
{
	char nom[100];
	char nom_suiv[100];
	char lettre[25];
	int etat_mode = 0;
	int nb_trans = 0;
	int i;
	
	if(fscanf(entree, "%99s %d %d", nom, &etat_mode, &nb_trans) != 3)
		return -1;
	if(! Automate_existe_etat(automate, (Mot)nom))
	{
		if(! Automate_ajouter_etat(automate, (Mot)nom))
			return 0;
	}
	if(etat_mode % 2 == 1)
	{
		if(! Automate_ajouter_etat_initial(automate, (Mot)nom))
			return 0;
	}
	if(etat_mode / 2 == 1)
	{
		if(! Automate_ajouter_etat_final(automate, (Mot)nom))
			return 0;
	}
	for(i = 0; i < nb_trans; ++i)
	{
		if(fscanf(entree, "%24s %99s", lettre, nom_suiv) != 2)
			return 0;
		if(! Automate_existe_etat(automate, (Mot)nom_suiv))
		{
			if(! Automate_ajouter_etat(automate, (Mot)nom_suiv))
				return 0;
		}
		if(! Automate_existe_transition(automate, (Mot)nom, (Mot)lettre, (Mot)nom_suiv))
		{
			if(! Automate_ajouter_transition(automate, (Mot)nom, (Mot)lettre, (Mot)nom_suiv))
				return 0;
		}
	}
	return 1;
}

int Automate_charger(Automate automate, FILE * entree)
{
	int retour;
	while((retour = Automate_charger_etat(automate, entree)) == 1);
	return retour == -1;
}
